<template>
  <b-container id="detail-view">
    <b-row id="metadataManagerButtonRowTop" align-h="between">
      <b-col>
        <b-button
          id="buttonSelectFiles"
          ref="buttonSelectFiles"
          variant="secondary"
          @click="selectFiles()"
          :placeholder="$t('metadataManagerBtnSelectFiles')"
          :disabled="
            isUploading || resourceContentSettings.readOnly || resource.Archived
          "
          >{{ $t("metadataManagerBtnSelectFiles") }}
        </b-button>
      </b-col>
      <b-col>
        <b-input-group id="metadataManagerDropDownMenu" class="float-right">
          <b-dropdown
            size="sm"
            right
            :no-caret="true"
            id="addColumnDropDown"
            :disabled="!showDetail || resource.Archived"
          >
            <template v-slot:button-content>
              <i class="material-icons">arrow_drop_down</i>
            </template>
            <b-dropdown-item
              v-if="showDetail"
              @click="showModalDeleteFiles()"
              >{{ $t("metadataManagerBtnDelete") }}</b-dropdown-item
            >
          </b-dropdown>
          <b-button
            v-if="!resourceContentSettings.metadataView.editableDataUrl"
            @click="download()"
            :disabled="!showDetail || shownFiles.length === 0"
            >{{ $t("metadataManagerBtnDownload") }}</b-button
          >
        </b-input-group>
      </b-col>
    </b-row>
    <b-row
      id="metadataManagerShownFilesTable"
      v-show="
        showDetail ||
        resourceContentSettings.metadataView.editableDataUrl === false ||
        resourceContentSettings.metadataView.editableKey === false
      "
    >
      <b-col>
        <b-input-group v-for="(item, index) in shownFiles" :key="index">
          <b-button
            @click="changeMetadata(index)"
            :pressed="currentFileId === index"
            >{{ index + 1 }}</b-button
          >
          <b-button
            @click="changeMetadata(index)"
            class="metadataManagerFileListFileName"
            :pressed="false"
            >{{ item.name
            }}<b-spinner v-show="item.uploading" label="Spinning"></b-spinner
          ></b-button>
          <b-button
            class="deleteFileFromList"
            @click="removeElement(index)"
            :disabled="item.uploading"
            >X</b-button
          >
        </b-input-group>
      </b-col>
    </b-row>
    <b-row id="metadataManagerQuickAccess" v-show="shownFiles.length > 1">
      <b-col>
        <b-button @click="loadAllFilesTab()" :pressed="currentFileId === -1">{{
          $t("allFiles")
        }}</b-button>
        <span v-if="shownFiles.length > 1 && shownFiles.length <= 10">
          <b-button
            v-for="(item, index) in shownFiles"
            :key="index"
            :pressed="currentFileId === index"
            @click="changeMetadata(index)"
            class="metadataTabButton"
            >{{ index + 1 }}</b-button
          >
        </span>
      </b-col>
    </b-row>
    <b-row id="metadataManagerFileName" class="text-center">
      <b-col>
        <span
          class="showSpaces"
          v-if="currentFileId >= 0 && currentFileId < shownFiles.length"
        >
          {{ shownFiles[currentFileId].name }}
        </span>
        <span v-else-if="shownFiles.length > 0">{{ $t("allFiles") }}</span>
      </b-col>
    </b-row>
    <b-row id="metadataManagerMetadataSection">
      <b-col>
        <span
          v-if="
            showDetail &&
            fileListEdit.length > 0 &&
            currentFileId >= 0 &&
            currentFileId < fileListEdit.length
          "
        >
          <coscine-form-group :label="$t('infoFileName')">
            <div class="fileInfoField">
              {{
                fileListEdit[currentFileId].name === null ||
                fileListEdit[currentFileId].name === ""
                  ? $t("infoFileNoInformation")
                  : fileListEdit[currentFileId].name
              }}
            </div>
          </coscine-form-group>
          <coscine-form-group :label="$t('infoFileLastModified')">
            <div class="fileInfoField">
              {{
                fileListEdit[currentFileId].lastModified === undefined ||
                fileListEdit[currentFileId].lastModified === null ||
                fileListEdit[currentFileId].lastModified === ""
                  ? $t("infoFileNoInformation")
                  : new Date(
                      fileListEdit[currentFileId].lastModified
                    ).toLocaleDateString($i18n.locale)
              }}
            </div>
          </coscine-form-group>
          <coscine-form-group :label="$t('infoFileCreated')">
            <div class="fileInfoField">
              {{
                fileListEdit[currentFileId].created === undefined ||
                fileListEdit[currentFileId].created === null ||
                fileListEdit[currentFileId].created === ""
                  ? $t("infoFileNoInformation")
                  : new Date(
                      fileListEdit[currentFileId].created
                    ).toLocaleDateString($i18n.locale)
              }}
            </div>
          </coscine-form-group>
          <coscine-form-group :label="$t('infoFileSize')">
            <div class="fileInfoField">
              {{
                fileListEdit[currentFileId].size === undefined ||
                fileListEdit[currentFileId].size === null
                  ? $t("infoFileNoInformation")
                  : fileListEdit[currentFileId].size + " Bytes"
              }}
            </div>
          </coscine-form-group>
        </span>
        <span
          v-if="
            resourceContentSettings.metadataView.editableDataUrl &&
            shownFiles.length > 0 &&
            currentFileId >= 0
          "
        >
          <coscine-form-group
            :mandatory="true"
            labelFor="dataUrl"
            :label="$t('dataUrl')"
          >
            <b-input-group>
              <b-form-input
                id="dataUrl"
                v-model="shownFiles[currentFileId].dataUrl"
                :placeholder="$t('dataUrl')"
                :disabled="resource.Archived"
              />
              <b-button
                id="URLBtn"
                @click="openURL()"
                :disabled="
                  !showDetail || shownFiles.length === 0 || !isValidUrl
                "
                ><b-icon-link-45deg />
              </b-button>
            </b-input-group>
          </coscine-form-group>
        </span>
        <span
          v-if="
            resourceContentSettings.metadataView.editableKey &&
            shownFiles.length > 0 &&
            currentFileId >= 0
          "
        >
          <coscine-form-group
            :mandatory="true"
            labelFor="metadataKey"
            :label="$t('metadataKey')"
          >
            <b-form-input
              v-model="shownFiles[currentFileId].name"
              @change="updateAbsolutePath(shownFiles[currentFileId])"
              :placeholder="$t('metadataKey')"
              :disabled="resource.Archived"
            />
          </coscine-form-group>
        </span>
        <span v-if="applicationProfileId !== ''" class="generatedFormSpan">
          <FormGenerator
            class="generatedForm"
            :key="formGeneratorKey"
            :applicationProfileId="applicationProfileId"
            :fixedValues="resource.fixedValues"
            :formData="currentMetadata"
            :SHACLDefinition="JSON.stringify(applicationProfile)"
            :disabledMode="resource.Archived"
            mimeType="application/ld+json"
            @isValid="isValid"
          />
        </span>
      </b-col>
    </b-row>
    <b-row id="metadataManagerButtonRowBottom">
      <span class="processStatement" v-if="isUploading"
        >{{
          totalNumberOfCurrentlyProcessedFiles -
          numberOfCurrentlyProcessedFiles
        }}/{{ totalNumberOfCurrentlyProcessedFiles }}</span
      >
      <div
        id="metadataManagerButtonRowBottomContainer"
        :class="saveButtonDisabled ? 'buttondisabled' : ''"
      >
        <b-col>
          <b-progress
            v-if="isUploading"
            class="metadataManagerButtonRowProgress"
            :value="progressStatus"
            max="100"
            show-progress
            animated
          ></b-progress>
        </b-col>
        <b-col id="metadataManagerButtonCol">
          <b-button
            id="metadataManagerButtonRowBottomSave"
            class="metadataManagerButtonRowBottomSave"
            variant="primary"
            @click="
              isUploading
                ? undefined
                : !showDetail
                ? uploadPreparation()
                : update()
            "
            :disabled="saveButtonDisabled"
            ><b-spinner label="Spinning" v-show="isUploading"></b-spinner
            >{{
              isUploading
                ? $t("metadataManagerBtnSaving")
                : !showDetail
                ? $t("metadataManagerBtnUpload")
                : $t("metadataManagerBtnUpdate")
            }}</b-button
          >
        </b-col>
      </div>
    </b-row>
    <b-popover
      :disabled="valid || validationResults.length === 0"
      over
      custom-class="b-popover"
      target="metadataManagerButtonCol"
      triggers="hover focus"
      placement="top"
    >
      <template v-slot:title
        ><b>{{ $t("validationErrors") }}</b></template
      >
      <div>
        <ul>
          <li
            v-for="validationResult of validationResults"
            :key="validationResult.term.value"
          >
            {{ validationResult.path.value }}
            <ul>
              <li
                v-for="singleMessage of validationResult.message"
                :key="singleMessage.value"
              >
                {{ singleMessage.value }}
              </li>
            </ul>
          </li>
        </ul>
      </div>
    </b-popover>
    <b-modal
      id="modalLeavingPage"
      @hidden="hiddenModal()"
      @shown="shownModalLeavingPage()"
      ref="modalLeavingPage"
      size="lg"
      hide-footer
      :title="$t('modalLeavingPageHeader')"
    >
      <div>{{ $t("modalLeavingPageBodyTop") }}</div>
      <div
        v-for="(item, index) in currentlyUploadedFiles"
        :key="index"
        class="modalFile"
      >
        {{ item.name }}
      </div>
      <div>{{ $t("modalLeavingPageBodyBottom") }}</div>
      <b-button class="modalButtonFloatLeft" @click="leaveModalLeavingPage">{{
        $t("modalLeavingPageBtnLeave")
      }}</b-button>
      <b-button
        class="modalButtonFloatRight"
        @click="stayModalLeavingPage"
        ref="modalLeavingPageStay"
        autofocus
        >{{ $t("modalLeavingPageBtnStay") }}</b-button
      >
    </b-modal>
    <b-modal
      id="modalSaveDuplicateFiles"
      @hidden="hiddenModal()"
      @shown="shownModalSaveDuplicateFiles()"
      ref="modalSaveDuplicateFiles"
      size="lg"
      hide-footer
      :title="$t('modalSaveDuplicateFilesHeader')"
    >
      <div>{{ $t("modalSaveDuplicateFilesBody") }}</div>
      <div
        v-for="(item, index) in uploadFileListReplaceFiles"
        :key="index"
        class="modalFile"
      >
        {{ item.name }}
      </div>
      <b-button
        class="modalButtonFloatLeft"
        @click="hideModalSaveDuplicateFiles"
        ref="modalSaveDuplicateFilesCancel"
        autofocus
        >{{ $t("modalSaveDuplicateFilesBtnCancel") }}</b-button
      >
      <b-button
        class="modalButtonFloatCenter"
        @click="skipModalSaveDuplicateFiles"
        >{{ $t("modalSaveDuplicateFilesBtnSkip") }}</b-button
      >
      <b-button
        class="modalButtonFloatRight"
        @click="overwriteModalSaveDuplicateFiles"
        >{{ $t("modalSaveDuplicateFilesBtnOverwrite") }}</b-button
      >
    </b-modal>
    <b-modal
      id="modalDeleteFiles"
      @hidden="hiddenModal()"
      @shown="shownModalDeleteFiles()"
      ref="modalDeleteFiles"
      size="lg"
      hide-footer
      :title="$t('modalDeleteFilesHeader')"
    >
      <div>{{ $t("modalDeleteFilesBody") }}</div>
      <div v-for="(item, index) in shownFiles" :key="index" class="modalFile">
        {{ item.name }}
      </div>
      <b-button
        class="modalButtonFloatLeft"
        @click="hideModalDeleteFiles"
        ref="modalDeleteFilesCancel"
        autofocus
        >{{ $t("modalDeleteFilesBtnCancel") }}</b-button
      >
      <b-button
        class="modalButtonFloatRight deleteFiles"
        @click="deleteModalDeleteFiles"
        >{{ $t("modalDeleteFilesBtnDelete") }}</b-button
      >
    </b-modal>
  </b-container>
</template>

<script lang="ts">
import Vue, { PropType, VNode } from "vue";
import { BlobApi, TreeApi } from "@coscine/api-client";
import { BIconLink45deg } from "bootstrap-vue";
import fileSaver from "file-saver";

import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import MetadataManagerUtil from "../utils/MetadataManagerUtil";

import ResourceContentSettings from "@/global";

import FormGenerator from "@coscine/form-generator";
import "@coscine/form-generator/dist/index.css";
import { EntryDefinition } from "@/utils/EntryDefinition";

Vue.use(FormGenerator);

export default Vue.extend({
  name: "DetailView",
  components: {
    BIconLink45deg,
    CoscineFormGroup,
  },
  data() {
    return {
      numberOfCurrentlyProcessedFiles: 0,
      totalNumberOfCurrentlyProcessedFiles: 0,
      uploadDuplicates: true,
      inputOk: false,
      showBadFileNameAlert: false,
      shownFiles: [] as EntryDefinition[],
      allFilesEdit: {} as { [index: string]: any },
      allFilesUpload: {} as { [index: string]: any },
      currentFileId: -1,
      uploadFileListNewFiles: [] as EntryDefinition[],
      uploadFileListReplaceFiles: [] as EntryDefinition[],
      modalIsVisible: false,
      fileListError: [] as EntryDefinition[],
      currentlyUploadedFiles: [] as EntryDefinition[],
      progressStatus: 0,
      valid: false,
      validationResults: [] as any[],
    };
  },
  props: {
    resource: {
      default() {
        return {};
      },
      type: Object,
    },
    resourceId: String,
    showDetail: Boolean,
    isUploading: Boolean,
    fileListEdit: {
      default() {
        return [];
      },
      type: Array as PropType<EntryDefinition[]>,
    },
    fileListUpload: {
      default() {
        return [];
      },
      type: Array as PropType<EntryDefinition[]>,
    },
    folder: {
      default() {
        return [];
      },
      type: Array as PropType<EntryDefinition[]>,
    },
    currentFolder: {
      default: "/",
      type: String,
    },
    applicationProfile: Array,
    applicationProfileId: String,
    resourceContentSettings: Object as () => ResourceContentSettings,
  },
  created() {
    this.allFilesEdit = {
      "http://www.w3.org/1999/02/22-rdf-syntax-ns#type": [
        { type: "uri", value: this.applicationProfileId },
      ],
    };
    this.allFilesUpload = {
      "http://www.w3.org/1999/02/22-rdf-syntax-ns#type": [
        { type: "uri", value: this.applicationProfileId },
      ],
    };
    this.getOptions();
  },
  mounted() {
    (this.$refs.buttonSelectFiles as any).focus();
  },
  watch: {
    resourceContentSettings() {
      if (this.resourceContentSettings.metadataView.editableDataUrl) {
        this.fileListEdit.length = 0;
        this.fileListUpload.length = 0;
        this.fileListUpload.push({
          path: this.currentFolder,
          version: "1.0.0",
          uploading: false,
          name: "",
          metadata: {},
          isFolder: false,
          absolutepath: this.currentFolder,
        });
      } else {
        if (this.$refs.fileTrigger) {
          (this.$refs.fileTrigger as any).$el.click();
        }
      }
    },
    fileListUpload() {
      this.getOptions();
      this.checkInputConstraints();
    },
    fileListEdit() {
      this.getOptions();
    },
    modalIsVisible() {
      if (!this.modalIsVisible) {
        this.$nextTick(() => {
          (this.$refs.buttonSelectFiles as any).focus();
        });
      }
    },
  },
  computed: {
    currentMetadata(): Record<string, unknown> {
      if (
        this.currentFileId >= 0 &&
        this.currentFileId < this.shownFiles.length
      ) {
        if (this.shownFiles[this.currentFileId].metadata !== undefined) {
          return this.shownFiles[this.currentFileId].metadata as Record<
            string,
            unknown
          >;
        } else {
          return {};
        }
      } else {
        if (this.showDetail) {
          return this.allFilesEdit;
        } else {
          return this.allFilesUpload;
        }
      }
    },
    formGeneratorKey(): string {
      return (
        "" +
        this.showDetail +
        (this.fileListUpload.length !== 0) +
        this.currentFileId +
        this.getFileNameOrDefault() +
        this.getFileIdOrDefault()
      );
    },
    isValidUrl(): boolean {
      const dataUrl = this.shownFiles[this.currentFileId].dataUrl;
      if (dataUrl === undefined) {
        return false;
      }
      let url: URL;
      const validUrl =
        /^(http[s]?:\/\/){0,1}(www\.){0,1}[a-zA-Z0-9.-]+\.[a-zA-Z]{2,5}[.]{0,1}/;
      try {
        if (dataUrl.includes("://")) {
          url = new URL(dataUrl);
        } else {
          url = new URL("http://" + dataUrl);
        }
      } catch {
        return false;
      }
      return validUrl.test(url.toString());
    },
    saveButtonDisabled(): boolean {
      return this.resource.Archived || !this.valid || this.isUploading;
    },
  },
  methods: {
    getFileNameOrDefault() {
      if (
        this.currentFileId >= 0 &&
        this.currentFileId < this.shownFiles.length
      ) {
        return this.shownFiles[this.currentFileId].name;
      }
      return "";
    },
    getFileIdOrDefault() {
      if (
        this.currentFileId >= 0 &&
        this.currentFileId < this.shownFiles.length &&
        this.shownFiles[this.currentFileId].id
      ) {
        return this.shownFiles[this.currentFileId].id;
      }
      return "";
    },
    applyMetadataTemplate(template: any) {
      const keyList = Object.keys(template);
      if (keyList.length > 0) {
        for (const key of keyList) {
          if (template[key][0].value !== "") {
            for (const currentFile of this.shownFiles) {
              const innerKeyList = Object.keys(template[key][0]);
              const file = currentFile;
              if (file.metadata === undefined) {
                file.metadata = {};
              }
              file.metadata[key] = [];
              file.metadata[key].push({});
              for (const innerKey of innerKeyList) {
                file.metadata[key][0][innerKey] = template[key][0][innerKey];
              }
            }
          }
        }
      }
    },
    isValid(valid: { conforms: boolean; results: [] }) {
      this.valid = valid.conforms;
      this.validationResults = valid.results;
    },
    loadAllFilesTab() {
      this.currentFileId = -1;
    },
    changeMetadata(index: number) {
      if (this.currentFileId === -1) {
        if (this.showDetail) {
          this.applyMetadataTemplate(this.allFilesEdit);
        } else {
          this.applyMetadataTemplate(this.allFilesUpload);
        }
      }
      this.currentFileId = index;
    },
    removeElement(index: number) {
      if (this.showDetail) {
        this.$emit("removeSelection", this.fileListEdit.splice(index, 1));
      } else {
        this.fileListUpload.splice(index, 1);
      }
    },
    adjustRemainingFiles(file: EntryDefinition, error = false, reload = false) {
      this.numberOfCurrentlyProcessedFiles -= 1;
      this.progressStatus = 0;
      file.uploading = false;
      if (error) {
        this.fileListError.push(file);
      }
      if (this.numberOfCurrentlyProcessedFiles === 0) {
        this.uploadDuplicates = true;
        this.$emit("isUploading", false);

        this.cleanup();

        if (reload) {
          location.reload();
        } else {
          const numberofSuccessfulUploadedFiles =
            this.totalNumberOfCurrentlyProcessedFiles -
            this.fileListError.length;

          if (this.fileListError.length > 0) {
            const h = this.$createElement;
            const content = [];
            content.push("" + this.$t("toastSavingFailedBodyTop"));
            content.push(h("br"));

            for (const fileWithError of this.fileListError) {
              content.push("" + fileWithError.name);
              content.push(h("br"));
            }

            content.push("" + this.$t("toastSavingFailedBodyBottom"));

            const vNodesMsg = h("span", {}, content);
            this.makeToast(
              "" + this.$t("toastSavingFailedTitle"),
              vNodesMsg,
              true
            );
          }
          if (numberofSuccessfulUploadedFiles > 0) {
            this.makeToast(
              "" + this.$t("toastSavingSuccessfulTitle"),
              "" +
                this.$t("toastSavingSuccessfulBody") +
                numberofSuccessfulUploadedFiles
            );
          }
        }
      }
    },
    initRemainingFiles(numberOfFiles: number) {
      this.fileListError = [];
      this.numberOfCurrentlyProcessedFiles = numberOfFiles;
      this.totalNumberOfCurrentlyProcessedFiles = numberOfFiles;
      for (const currentFile of this.shownFiles) {
        const file = currentFile;
        if (
          this.uploadDuplicates ||
          this.folder.find((x) => x.name === file.name) === undefined
        ) {
          file.uploading = true;
        }
      }
      if (this.numberOfCurrentlyProcessedFiles > 0) {
        this.$emit("isUploading", true);
      }
    },
    fileNamesOk() {
      const charFilter = new RegExp("[\\/:?*<>|]+");
      if (this.fileListUpload.length === 0) {
        return false;
      }
      for (const file of this.fileListUpload) {
        if (charFilter.test(file.name)) {
          this.showBadFileNameAlert = true;
          return false;
        }
      }
      this.showBadFileNameAlert = false;
      return true;
    },
    checkInputConstraints() {
      // TODO also consider application profile form validation results here
      // also make sure that input changes/ changes with form validation
      // and consider the file name restraints before activating the button
      if (this.fileNamesOk()) {
        this.inputOk = true;
      }
    },
    async uploadPreparation() {
      this.uploadFileListNewFiles = [];
      this.uploadFileListReplaceFiles = [];
      for (const fileToUpload of this.fileListUpload) {
        const file = fileToUpload;
        if (this.folder.find((x) => x.name === file.name) === undefined) {
          this.uploadFileListNewFiles.push(file);
        } else {
          this.uploadFileListReplaceFiles.push(file);
        }
      }
      if (this.uploadFileListReplaceFiles.length > 0) {
        this.showModalSaveDuplicateFiles();
      } else {
        await this.upload();
      }
    },
    async upload() {
      if (this.currentFileId === -1) {
        this.applyMetadataTemplate(this.allFilesUpload);
      }
      if (this.uploadDuplicates) {
        this.initRemainingFiles(this.fileListUpload.length);
        for (const fileToUpload of this.fileListUpload) {
          const file = fileToUpload;
          await this.uploadFile(file);
        }
      } else {
        this.initRemainingFiles(this.uploadFileListNewFiles.length);
        for (const fileToUpload of this.uploadFileListNewFiles) {
          const file = fileToUpload;
          await this.uploadFile(file);
        }
      }
    },
    async uploadFile(file: EntryDefinition) {
      this.removeEmptyValues(file);
      try {
        await TreeApi.treeStoreMetadataForFileWithParameter(
          this.resourceId,
          file.absolutepath,
          { data: file.metadata }
        );
        if (
          !this.resourceContentSettings.metadataView.editableDataUrl &&
          file.info
        ) {
          await this.handleUploadContent(file.info, file);
        } else if (file.dataUrl !== undefined) {
          this.fillData(file);
          const blob = new Blob([file.dataUrl], { type: "plain/text" });
          await this.handleUploadContent(blob, file);
        }
      } catch {
        this.adjustRemainingFiles(file, true);
      }
    },
    fillData(file: EntryDefinition) {
      if (file.dataUrl === null || file.dataUrl === undefined) {
        file.dataUrl = "";
      }
      file.info = new File([file.dataUrl], file.name, {
        type: "text/plain",
      });
    },
    async handleUploadContent(contents: Blob, file: EntryDefinition) {
      this.progressStatus = 0;
      try {
        await BlobApi.blobUploadFileWithParameter(
          this.resourceId,
          file.absolutepath,
          [contents],
          {
            onUploadProgress: (progressEvent: ProgressEvent) => {
              this.progressStatus = Math.round(
                (progressEvent.loaded * 100) / progressEvent.total
              );
            },
          }
        );
      } catch {
        this.adjustRemainingFiles(file, true);
        return;
      }

      const entry = this.folder.find((x) => x.name === file.name);
      if (entry === undefined) {
        const newRow: EntryDefinition = {
          isFolder: false,
          name: file.name,
          absolutepath: file.absolutepath,
          lastModified: new Date().toString(),
          created: new Date().toString(),
          size: file.size,
          path: file.path,
          info: file.info,
        };
        MetadataManagerUtil.copyMetadata(file.metadata, newRow, false);
        this.folder.push(newRow);
      } else {
        entry.lastModified = new Date().toString();
        entry.created = new Date().toString();
        entry.size = file.size;
        MetadataManagerUtil.copyMetadata(file.metadata, entry, false);
      }
      this.adjustRemainingFiles(file);
    },
    openURL() {
      if (this.showDetail) {
        if (
          this.resourceContentSettings.metadataView.editableDataUrl === true &&
          this.resourceContentSettings.metadataView.editableKey === true
        ) {
          let url = this.shownFiles[this.currentFileId].dataUrl;
          if (url !== undefined && !url.includes("://")) {
            url = "http://" + url;
          }
          const win = window.open(url, "_blank");
          if (win !== null) {
            win.focus();
          }
        }
      }
    },
    async download() {
      if (this.showDetail) {
        for (const editableFile of this.shownFiles) {
          const response = await BlobApi.blobGetFileWithParameter(
            this.resourceId,
            editableFile.absolutepath,
            {
              responseType: "blob",
            }
          );
          fileSaver.saveAs(response.data, editableFile.name);
          window.location.hash = window.location.hash.substring(
            0,
            window.location.hash.lastIndexOf("/")
          );
        }
      }
    },
    selectFiles() {
      this.$emit("clickFileSelect");
    },
    async update() {
      if (this.currentFileId === -1) {
        this.applyMetadataTemplate(this.allFilesEdit);
      }
      this.initRemainingFiles(this.fileListEdit.length);

      for (const editableFile of this.fileListEdit) {
        const file = editableFile as EntryDefinition;

        this.removeEmptyValues(file);

        try {
          await TreeApi.treeStoreMetadataForFileWithParameter(
            this.resourceId,
            file.absolutepath,
            { data: file.metadata }
          );
          const tmp = this.folder.find((x) => x.name === file.name);
          if (
            this.resourceContentSettings.metadataView.editableDataUrl &&
            file.dataUrl !== undefined
          ) {
            this.fillData(file);
            const blob = new Blob([file.dataUrl], { type: "plain/text" });
            await this.handleUploadContent(blob, file);
          } else {
            MetadataManagerUtil.copyMetadata(file.metadata, tmp, false);
            this.adjustRemainingFiles(file);
          }
        } catch {
          this.adjustRemainingFiles(file, true);
        }
      }
    },
    removeEmptyValues(file: EntryDefinition) {
      // remove empty nodes
      for (const node in file.metadata) {
        const property = file.metadata[node];
        if (
          property.length === 0 ||
          property[0].value === undefined ||
          property[0].value === null ||
          property[0].value.trim() === ""
        ) {
          delete file.metadata[node];
        }
      }
    },
    async deleteFiles() {
      this.initRemainingFiles(this.fileListEdit.length);

      for (const fileToDelete of this.fileListEdit) {
        await this.deleteFile(fileToDelete);
      }
      this.cleanup();
    },
    async deleteFile(file: EntryDefinition) {
      let failure = false;
      try {
        await BlobApi.blobDeleteFileWithParameter(
          this.resourceId,
          file.absolutepath
        );
      } catch {
        failure = true;
      }
      this.adjustRemainingFiles(file, failure, true);
    },
    async getOptions() {
      this.shownFiles = [] as EntryDefinition[];
      if (this.showDetail) {
        this.shownFiles = this.fileListEdit;
      } else if (this.fileListUpload.length !== 0) {
        this.shownFiles = this.fileListUpload;
      }
      if (this.shownFiles.length === 1) {
        this.currentFileId = 0;
      }
      if (this.resourceContentSettings.metadataView.editableDataUrl) {
        for (const file of this.shownFiles) {
          const element = file;
          if (element.requesting || element.path === "") {
            return;
          }
          element.requesting = true;
          const response = await BlobApi.blobGetFileWithParameter(
            this.resourceId,
            element.absolutepath
          );
          this.$set(element, "dataUrl", response.data);
          element.requesting = false;
        }
      }
    },
    cleanup() {
      this.fileListUpload.length = 0;
    },
    makeToast(
      givenTitle = "Title",
      text: string | VNode | VNode[] = "Message",
      error = false
    ) {
      if (error) {
        this.$bvToast.toast(text, {
          title: givenTitle,
          noAutoHide: true,
          variant: "warning",
          toaster: "b-toaster-bottom-right",
        });
      } else {
        this.$bvToast.toast(text, {
          title: givenTitle,
          toaster: "b-toaster-bottom-right",
          noCloseButton: true,
        });
      }
    },
    showModalLeavingPage() {
      this.currentlyUploadedFiles = [];
      for (const currentFile of this.fileListEdit) {
        const file = currentFile;
        this.currentlyUploadedFiles.push(file);
      }
      for (const currentFile of this.fileListUpload) {
        const file = currentFile;
        this.currentlyUploadedFiles.push(file);
      }
      (this.$refs.modalLeavingPage as any).show();
      this.modalIsVisible = true;
    },
    shownModalLeavingPage() {
      this.$nextTick(() => {
        (this.$refs.modalLeavingPageStay as any).focus();
      });
    },
    stayModalLeavingPage() {
      (this.$refs.modalLeavingPage as any).hide();
    },
    leaveModalLeavingPage() {
      (this.$refs.modalLeavingPage as any).hide();
    },
    showModalDeleteFiles() {
      (this.$refs.modalDeleteFiles as any).show();
      this.modalIsVisible = true;
    },
    shownModalDeleteFiles() {
      this.$nextTick(() => {
        (this.$refs.modalDeleteFilesCancel as any).focus();
      });
    },
    hideModalDeleteFiles() {
      (this.$refs.modalDeleteFiles as any).hide();
    },
    async deleteModalDeleteFiles() {
      (this.$refs.modalDeleteFiles as any).hide();
      await this.deleteFiles();
    },
    showModalSaveDuplicateFiles() {
      (this.$refs.modalSaveDuplicateFiles as any).show();
      this.modalIsVisible = true;
    },
    shownModalSaveDuplicateFiles() {
      this.$nextTick(() => {
        (this.$refs.modalSaveDuplicateFilesCancel as any).focus();
      });
    },
    hideModalSaveDuplicateFiles() {
      (this.$refs.modalSaveDuplicateFiles as any).hide();
    },
    overwriteModalSaveDuplicateFiles() {
      this.uploadDuplicates = true;
      (this.$refs.modalSaveDuplicateFiles as any).hide();
      this.upload();
    },
    skipModalSaveDuplicateFiles() {
      this.uploadDuplicates = false;
      (this.$refs.modalSaveDuplicateFiles as any).hide();
      this.upload();
    },
    hiddenModal() {
      this.modalIsVisible = false;
    },
    updateAbsolutePath(entry: EntryDefinition) {
      entry.path = entry.path !== "" ? entry.path : "/";
      entry.absolutepath = entry.path + entry.name;
    },
  },
});
</script>

<style>
#detail-view .form-group.mandatory .col-form-label:after {
  content: " *";
  color: #a70619;
}
#detail-view .col-form-label.col-sm-3 {
  font-weight: bold;
}
.select-fullwidth {
  width: 100%;
}
.modal-backdrop {
  opacity: 0.5;
}
.generatedForm {
  margin-top: 10px;
}
.fileInfo {
  font-weight: bold;
}
.metadataTabButton {
  max-width: inherit;
  min-width: inherit;
  width: inherit;
}
.modal-header .modal-title {
  margin-block-start: 0;
  margin-block-end: 0;
  margin-left: 0;
}
.modal-header button.close {
  text-align: end;
  min-width: 1em;
}
.modal footer button {
  min-width: auto;
}
.modal-backdrop {
  opacity: 0.5;
}
.modal .modalButtonFloatLeft {
  float: left;
}
.modal .modalButtonFloatCenter {
  position: absolute;
  left: 40%;
  right: 40%;
  white-space: nowrap;
}
.modal .modalButtonFloatRight {
  float: right;
}
.modal .deleteFiles:hover {
  background-color: #9b0517;
  border-color: #8e0515;
  color: #ffffff;
}
.metadataManagerFileListFileName {
  text-overflow: ellipsis;
}
#metadataManagerDiv .input-group button {
  border-radius: 0px;
}
#metadataManagerDiv .input-group button:first-child {
  border-top-left-radius: 0.25rem;
  border-bottom-left-radius: 0.25rem;
}
#metadataManagerDiv .input-group button:last-child {
  border-top-right-radius: 0.25rem;
  border-bottom-right-radius: 0.25rem;
}
</style>

<style scoped>
#detail-view {
  flex-direction: column;
  display: flex;
  max-height: 100%;
}
.invalid-tooltip {
  margin-top: -20px;
}
#displayName {
  font-size: large;
  padding-bottom: 0.3em;
}
button span.spinner-border {
  height: 15px;
  width: 15px;
  margin-right: 4px;
}
#metadataManagerDropDownMenu {
  margin-top: 5px;
  margin-right: 5px;
  width: auto;
}
#metadataManagerShownFilesTable {
  margin-left: 5px;
  margin-right: 5px;
}
#metadataManagerShownFilesTable .col {
  overflow-x: hidden;
  overflow-y: auto;
  max-height: 150px;
  padding-right: 0px;
  margin-right: 15px;
}
#metadataManagerShownFilesTable .input-group {
  flex-wrap: initial;
}
#metadataManagerShownFilesTable .metadataManagerFileListFileName {
  width: inherit;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  text-transform: none;
}
#metadataManagerShownFilesTable .spinner-border {
  margin-left: 5px;
}
#metadataManagerShownFilesTable .deleteFileFromList {
  color: red;
}
#metadataManagerQuickAccess {
  left: 0;
  right: 0;
}
#metadataManagerFileName {
  margin-top: 5px;
  left: 0;
  right: 0;
}
#metadataManagerFileName span {
  text-align: center;
  font-weight: bold;
  width: 100%;
}
#metadataManagerMetadataSection {
  overflow-x: hidden;
  overflow-y: auto;
  margin-bottom: 20px;
  padding-right: 0px;
  margin-right: 20px;
}
#metadataManagerMetadataSection .generatedFormSpan {
  width: 100%;
}
#metadataManagerMetadataSection .fileInfo {
  padding-right: 0px;
}
#metadataManagerMetadataSection .generatedForm {
  width: 100%;
}
#metadataManagerButtonRowBottom {
  position: absolute;
  bottom: 45px;
  width: 100%;
}
#metadataManagerButtonRowBottom #metadataManagerButtonRowBottomContainer {
  display: inline-flex;
  position: absolute;
  right: 0px;
  width: auto;
  height: 33px;
}
#metadataManagerButtonRowBottom
  #metadataManagerButtonRowBottomContainer.buttondisabled {
  cursor: not-allowed;
}
#metadataManagerButtonRowBottom .metadataManagerButtonRowBottomSave.disabled {
  pointer-events: none;
}
#metadataManagerButtonRowBottom .metadataManagerButtonRowProgress {
  width: 350px;
  margin-top: 13px;
}
#metadataManagerButtonRowBottom .processStatement {
  position: absolute;
  top: 13px;
  left: 20px;
}
#URLBtn {
  min-width: 0px;
}
.showSpaces {
  white-space: pre;
}
.fileInfoField {
  padding-top: calc(0.375rem + 1px);
  padding-bottom: calc(0.375rem + 1px);
}
</style>
